## RiskyMod

A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well.
The dream is a universal ruleset that anyone can host, similar to 1's.

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found here. https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority (Except for Bandit Grace Period).

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

## Main Features

- Removed proc chains.
- Made difficulty scaling linear (exponential jump on-loop) and increased spawnrates.
- Oneshot Protection now works as you would expect.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
	- Transcendence/Perfected Affix disable Oneshot Protection due to having shieldgating built-in.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage.
	- Most forms of range scaling have been removed.
- Drones performance now remains the same on all stages. (WiP)

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- Make Corpsebloom less bad.
- Make Desk Plant less bad.
- Rework Elixir/Watch.
- Make Aureleonite/AWU as OP as they were in earlier builds?
- More Survivor Tweaks
	- Captain
		- Turn beacons into deployables that recharge every 30s
		- Rework Hack/Resupply (Amped Weapons/Cooldown Reduction respectively?)
		- Buff Shock beacons?
		- Add Admiral's fans as a selectable beacon.
		- Figure out what to do with Microbots.
			- I don't like them, but what do people want from them?
			- Find some way to prevent players from getting free red scrap with DropInMultiplayer.
	- Artificer
		- Elemental combo interactions.
		- Shift rework.
	- Void Fiend
		- Special changes if you get 100% minimum corruption?
	- Bandit
		- Investigate secondaries. Noticed Hemmorhage stacking not doing much past the first loop.
- Enemy Tweaks
	- Rework certain enemies.
		- Mushrums
			- Shift focus from damage to AOE.
			- Change what stages they show up on (no Mushrums on Sky Meadow)
			- Healing skill only gets used if players are 30m away?
				- It's countered with Stuns, but not all characters have access to Stuns.
		- Lunar Wisps
			- Change to be projectile-based since hitscan is ass to fight, especially so on a wide-open map with no cover.
	- Tweak stage enemy pools to be more varied.
		- Greater Wisps on less stages.
		- Remove the Greater Wisp/Bronzong combo since they overlap too much rolewise.
		- Beetle Guards on more stages?
			- Might not be necessary due to Beetle Queens
		- Stadia Jungle
			- Vultures instead of Lemurians?
			- Beetle Guards instead of Golems?
				- Might not work due to heavy verticality.
		- Reduce boss overlap (no Vagrants 4 stages in a row).
			- Is this even possible with RoR2's small boss pool?
		- Adjust DLC1 enemy distribution.
			- Remove Blind Pest + Wisp combo due to role overlap.
			- Remove Alpha Constructs from most stages.
				- Or at least make them bleed out if they're far away from players.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM

## Changelog

`0.6.1`

- Fixed Tougher Times block chance not being updated in the logbook description.
- Fixed Commando's Phase Round description being used on his Primary.

`0.6.0`

*This is a huge update. Let me know if there's any bugs!*

- Voidtouched
	- Replaced Collapse with Nullify (EliteReworks takes precedence if you have it installed)
- Removed Distant Roost credit boost since it's Vanilla now.
- Run Scaling
	- Reduced per-loop exponential scaling from 1.18^x -> 1.15^x
	- Teleporter Bosses and Special Bosses now get Adaptive Armor while looping.
		- Only applies to boss enemies with a red healthbar.
		- Does not apply to Vengeance Doppelgangers.
		
	*Once Loops start, teleporter bosses end up toppling way too fast to do anything. This change only affects teleporter bosses since the idea is that naturally spawned boss enemies shouldn't be a barrier to progression through the stage. Worried that Adaptive Armor might make tele bosses too tanky, needs more testing.*

	- Increased max level to 9999 to match simulacrum
		
		*At a certain point, enemies stop spawning in Vanilla simulacrum. Need to figure out when that point is reached, and find out what to do there.*
	
- Simulacrum Scaling

	*Left untouched for now, need to see how Vanilla scaling fares against RiskyMod balance.*
	
- Void Locus
	- Holdout size increased 33%
	- Removed Void fog.
	
	*Void fog led to team wipes in large lobbies since it is impossible to coordinate everyone to stand inside a tiny circle, and the circles aren't very fun in the first place.*
		
- Player-controlled monsters now get 2.5 (+0.5/level) health regen and +20 armor if they don't already have built-in health regen.

	*This is only relevant if you use mods to play as enemies.*
	
- Oneshot Protection

	*Concerned that Opal + Safer Spaces + Shieldgating + OSP may be too effective at negating damage when combined together. Needs testing.*
	
- Shield Gating
	- Voidling Mega Laser now bypasses Shield Gating.
	
- Added a default AI Blacklist independent of item changes.
	- List contains:
		- Tougher Times
		- Unstable Tesla Coil
		- N'Kuhana's Opinion
		- Defensive Microbots
		- Spare Drone Parts
		- Ben's Raincoat
	- Can be toggled on/off in config.
	
	*Not sure how expansive this list should be. I personally use a much more restrictive blacklist with the standalone AI Blacklist plugin (https://thunderstore.io/package/Moffein/AI_Blacklist/). Might consider looking at certain items and specifically tweaking them for enemies at some point (ex. Bleeds, Medkits).*
	
- Artifacts
	- Enigma
		- Blacklisted Lunar Equipment, Recycler, Tricorn, and Executive Card.
		- Fixed being able to roll blacklisted Equipments.
		
		*For more in-depth options and custom blacklist settings, install the standalone https://thunderstore.io/package/Moffein/EnigmaBlacklist/ which overrides this.*
	
- Drones/Allies
	- Now immune to executes.
	- Now immune to Grandparent Suns.
	- Now immune to Void Fog.
	- Now immune to Void Implosions.
	- TC280
		- Damage increased from 70% -> 80%
		- HP increased from 80% -> 100%
	- Empathy Cores
		- Now affected by drone changes.
		- Damage reduced from 100% -> 80% due to drones/allies getting increased damage/level (20% -> 30%)
	
	*Telegraphed atatcks like Grandparent Suns and Void Implosions can easily be dodged by players, but Drones have no clue how to deal with them, and will simply stand in their radius and die.*

- Items
	- Cautious Slug
		- Increased regen from 3hp/s -> 4hp/s
		
		*This item was good in early builds of the game, but became pretty mediocre after health regen got changed. Hoping to bring back some of that strength.*

	- Tougher Times
		- Increased block chance from 7.5% -> 10%
		
		*Felt that the nerf made stacks a bit too underwhelming, especially when compared to Safer Space's guaranteed blocking. Need to be careful to not powercreep too hard when considering DLC items.*
		
	- Safer Spaces
	
		*10% -> 7% would make it equivalent to Tougher Times, but is it actually needed?*
		
	- Gasoline
		- Removed the modded damage scaling behavior due to Vanilla burn changes.
		
		*Need to get a feel for where it stands now before further adjustment is made.*
		
	- Warbanner
		- Removed bonus healing.
		- Now only triggers at the start of Mithrix's fight.
		- Now triggers when starting a holdout in Simulacrum (every 5 waves).
		
		*Healing was removed due to being overloaded with way too many features.*
		*TODO: Add to Voidling fight.*
		
	- Chronobauble
		- +15% damage vulnerability changed to -20% attack speed.
		
		*Bonus damage made the item good, but it didn't fit with the theming of the item at all. Swapping it to an attack speed debuff since no vanilla items provide this effect. Numbers may need tuning. Plan is to keep it below -30% since LiT's Prison Shackles does that already and is a perfectly viable item with that number.*
		
	- Lepton Daisy
		- Now also creates a 16m healing field that heals for 5% (+2.5%) max HP per second.
			- Only applies to Teleporters.
			- Counts every player's stacks.
		
		*Not sure if this combined with the healing novas is overkill, but at least this should help it be more than Scrapper fodder.*
		
	- Razor Wire
		- Full effect is now reached at -50% HP
		
		*Scaling changes seemed to make this item not effective against most normal hits, while Helfire + Razor Wire remained mostly the same due to the sheer spam it could put out.*
		
	- Rose Buckler
		- No longer multiplies total armor while sprinting.
		- Now gives +10 extra armor per stack while sprinting.
			- This stacks on top of the base passive +10 armor per stack.
		
		*Since Vanilla now has more reliable ways to get armor, the total armor multiplier ended up being excessive.*
		
	- Predatory Instincts
		- Disabled changes since they're Vanilla now.
		
	- Harvester's Scythe
		- Increased healing from 4 (+0.8/level) HP/s -> 5 (+1/level) HP/level
		
	- Red Whip
		- Now unconditionally gives +10% (+10%/stack) base move speed on top of its Vanilla effect.
		
		*Move speed makes a night and day difference between how the game plays, but only a few specific items actually give move speed unconditionally. This small buff should help with that.*
		
	- Hunter's Harpoon
		- Increased duration from 1s (+0.5s) -> 3s (+1.5s)
		- Can now trigger off of assists.
		
		*Vanilla duration is too low to be useful in any capacity.*
		
	- Ukulele
		- Damage per stack increased from +20% -> +24%
		
	- Sentient Meathook
		- Damage per stack increased from +25% -> +30% to match Ukulele's damage scaling.
		
		*Technically this scales way more than Ukulele due to targets+chance per stack, but I think it's fine since it's naturally hard to stack in the first place due to being a Red item.*
		
	- Brilliant Behemoth
		- Damage increased from 60% (+20%/stack) -> 60% (+36%/stack)
		
		*Stacking this item was pretty underwhelming, considering it's a red item and naturally hard to get stacks. New numbers match the stacking values of AtGs/Rings.*
		
	- Bottled Chaos
		- Blacklisted Volcanic Egg.
		
	- Ben's Raincoat
		(Credits to SOM for the buff icons!)
		- Replaced Vanilla Effect
		- Upon receiving a debuff, stun nearby enemies and gain debuff immunity for 3s. Recharges every 15s (-10%/stack, exponential)
			- Recharge starts at the end of the debuff immunity.
			- Minimum recharge cooldown is 1s.
		
		*Vanilla effect invalidates nearly all the Elites in the game. Trying to keep the spirit of countering debuffs without completely removing them from the game. Needs more testing and tweaking.*
		
	- Dormant Fungus
		- Reduced healing from 2% (+2%) -> 2% (+1%) to match Bustling Fungus scaling.
		
	- Plasma Shrimp
		- Reduced damage from 40% (+40%) -> 40% (+24%)
			- Original description says the damage is 40% (+50%), but that is incorrect.
		- Reduced proc coefficient from 0.2 -> 0
		
		*Changes to this item mirror AtG changes. This item is very good in Vanilla because it can trigger off of low proc coefficient passive item effects and proc chains along with proc spam, but does it still hold up once those are gone? Will need to playtest to find out.*
		
	- Voidsent Flame
		- Removed range scaling.
		- Reduced proc coefficient from 1.0 -> 0
		
		*Changes to this item mirror Will-o'-the-Wisp changes. Range remains at the default 12m as opposed to Wisp's increased 16m radius so that it isn't just a straight upgrade.*
		
	- Polylute
		- Reduced proc coefficient from 0.2 -> 0
		
	- Singularity Band
		- Changed damage from 100% (+100%) -> 150% (+90%)
		- Removed blast falloff (was Linear).
		- Reduced cooldown from 20s -> 15s
		- Reduced proc coefficient from 1.0 -> 0
		
		*Cool effect, but not worth taking over regular bands due to the long cooldown + low damage. Falloff removal should help this item's damage feel more consistent, instead of constantly whiffing for barely any damage. Damage scaling has been changed to match the scaling changes for Elemental Bands.*
		
	- Molten Perforator
		- Fixed fireballs not igniting enemies due to having no proc coefficient.
		
	- Transcendence
		- No longer blocks Bypass Shieldgate damage if you have Glass or are Cursed.
		
		*Since Cursed/Glass players have no defense against these attacks by default, Transcendence should not change that, or else it becomes a must-take for those builds.*
		
	- Gesture of the Drowned
		- Currently experimenting with changes in a standalone mod https://thunderstore.io/package/Moffein/GestureEnigma/
		
- Equipment
	- Ocular HUD
		- Changed how the crit bonus works.
			- Increases crit chance up to 100%.
			- Once crit is maxed, extra crit chance goes towards increasing your crit multiplier.
		
- Enemies
	- Beetle
		- Increased speed from 8.4 -> 10

	- Imp
		- Removed melee slowdown.
		- Tweaked AI so that they prioritize chasing the player instead of attempting to strafe when their melee is on cooldown.
		
		*Imps are supposed to be a mobile melee enemy, but they're terrible at chasing and keeping up with players. Their Vanilla AI makes them attempt to strafe after using their slash attack, letting players simply run away, and their slash attack has a 50% speed slowdown as well, ensuring that they'll never actually manage to hit anything moving.*
		
	- Blind Pest
		- Reduced HP from 80 -> 60
		- Reduced shot damage from 30 -> 12
		
		*This makes their HP the same as Jellyfish instead of Beetles, and shot damage the same as Lemurians.*
		
	- Void Infestor
		- Reduced HP from 45 -> 30
		- No longer possesses allies on the Player team.
		
		*These shouldn't be tankier than Wisps.*
		
- Acrid/Loader/MUL-T
	- Flying Knockdown Force
		- Capped force scaling at 1000kg.
		
		*This means that the heaviest enemy they can knock downwards is a Solus Control Unit. This is mainly to prevent weird interactions with Voidling, which is a fyling enemy.*
			
- Commando
	- Phase Blast
		- Damage increased from 170% -> 200%
		- Proc Coefficient reduced from 0.75 -> 0.5
		
	*Reverting to Vanilla stats since it currently is overshadowed by Phase Round. I believe Phase Round is in a good spot in its current state, so no changes are planned there.*

- Huntress
	- Unnerfed Phase Blink.
	
	*Phase Blink is strong in the context of Huntress's kit, but it's hardly impactful enough on the overall game state to justify nerfing, so it has been reverted to its Vanilla stats.*

- MUL-T
	- Rebar Puncher
		- Damage reduced from 720% -> 660%
		
		*The original idea was that a damage increase would allow it to be used full-time as a primary, but in practice it didn't actually work out that way. Damage has been reduced to be similar to what it was at the start of early access when MUL-T has 12 base damage.*
		
	- Scrap Launcher
		- Reload now scales with attack speed.
		- No longer interacts with cooldown reduction.

- Engi
	- Removed EngiAutoFire config options.
	
	*Debloating the config a bit. The option was disabled by default, and the standalone mod is compatible with RiskyMod.*
	
	- Mobile Turrets now sprint while firing.
	
	*Originally omitted this because I wanted to see if they'd be survivable enough with the defensive item changes from this mod, but it seems that always-sprint is necessary to make them hold up compared to Stationary Turrets.*
	
- Merc
	- Removed Expose changes since they're now Vanilla.
	- 3rd hit of M1 combo no longer scales with attack speed (so that Expose extension tech works even in lategame).
	
	*Inspired by Ya_boi_PHAT's MercenaryTweaks. Expose + Dash extension tech is cool, but it stops working once you get enough attack speed, so this fixes that. Not too concerned about the DPS loss since most of Merc's attack speed scaling comes from Eviscerate. This is a clientside setting.*
	
- Artificer
	- Primary reload now scales with attack speed.
		- 1s per shot.
		- Firing your primary skill resets the reload duration.
		- No longer interacts with cooldown reduction.
	
		*Was originally hesitant to add this because I was worried that it would lead to people simply machinegunning her primary, but after playing around with it for a bit, it seems fine. Bandit is in the same spot where he technically can machinegun his primary with enough attack speed, but no one really does it in practice.*
		
	- Fire Bolt
		- Damage increased from 220% -> 300%
		
		*This puts the total damage around the same as pre-ignite changes, with higher proccing damage. Also hitting a projectile attack with a considerable reload time should be worth as much as hitting a hitscan rifle shot (Bandit's Blast) at the bare minimum.*
		
	- Lightning Bolt
		- Damage increased from 220% -> 300%
	- Removed M2 input changes since M2 Requires Re-press is now Vanilla.
	- Removed Flamethrower changes since they're now Vanilla.
	- Removed Solid Ice Wall
	
		*Solid Ice Wall ended up being a hindrance, blocking your own shots from hitting while being hard to actually use as cover. More changes are planned for a later update.*
	
	- Nanobomb
		- Removed gravity.
	
- REX
	- Utilities
		- Maximum push force falloff reduced from -80% -> -50%
	- DIRECTIVE: Harvest
		- Fixed fruit drop chance being lower than intended. (Chance increased from 10% -> 15%)
		- Fruit healing increased from 20% HP -> 25% HP
		- Fruit pickup range increased from +30% -> +60%
		
- Bandit
	- Backstab
		- Crit chance is now converted to bonus crit damage (base minicrit multiplier is 1.5x).
		
	*I like the idea of crits being based on doing certain actions, rather than simply stacking glasses until they become an always-on thing. Additionally, the old minicrit code was a buggy mess. Not sure if Minicrit damage needs to be bumped up or if it's fine as-is.*
		
- Railgunner
	- Removed self-force from the Smartgun while grounded.
	- Removed self-force from the Railgun while grounded and standing still.
	- Alt Special can now execute bosses (tied to Freeze changes in Tweaks).
	
	*Trying to get more of a feel for Railgunner before deciding if anything else needs to be done. Her single target damage is really strong, but at the same time she has absolutely no crowd control, and this mod's lack of proc-chaining exacerbates that.*
	
- Void Fiend
	- Corruption
		- No longer reduced by healing.
		- No longer increased by crits.
		- Reduced Corrupt Transformation duration from 1s -> 0.6s
		- Corruption gain rate reduced from 3%/s -> 2%/s
		- Now gains +5% Corruption on kill/assist
		- Corrupted Form duration reduced from 15s -> 12s
		
		*Trying to make Corruption more based on player actions rather than things out of your control (unpredictable healing and reliance on Crits on a character with no built-in crit). Numbers may need tweaking.*
	
	- Corrupted Suppress
		- Now can be used an unlimited amount of times.
		
		*This can be spammed even when you're at 1HP, but staying at that HP range is a risky move so I think it's fine.*